use chrono::{DateTime, TimeZone, Utc};
pub use uuid::Uuid;
use uuid::{NoContext, Timestamp};

fn now() -> Timestamp {
    from_datetime(Utc::now())
}

fn from_datetime<T>(ts: DateTime<T>) -> Timestamp
where
    T: TimeZone,
{
    Timestamp::from_unix(
        NoContext,
        u64::from_ne_bytes(ts.timestamp().to_ne_bytes()),
        ts.timestamp_subsec_micros(),
    )
}

pub fn v7_now() -> Uuid {
    Uuid::new_v7(now())
}

pub fn v7<T: TimeZone>(dt: DateTime<T>) -> Uuid {
    Uuid::new_v7(from_datetime(dt))
}
